<template>
  <client-only>
    <header class="relative bg-black">
      <!-- Offvancas -->
      <div
        id="offcanvas"
        class="top-0 left-0 w-screen h-screen bg-black bg-opacity-75"
        :class="[{ 'z-40 fixed': offcanvas }, { absolute: !offcanvas }]"
      >
        <div
          class="relative z-50 w-3/4 h-screen bg-white shadow-lg sm:w-1/2 md:w-1/4"
          :class="[{ open: offcanvas }]"
        >
          <i
            class="absolute top-0 right-0 mt-2 -mr-16 text-5xl text-white cursor-pointer bx bx-x hover:text-primary-300"
            @click="offcanvas = false"
          ></i>
          <div
            class="flex items-center justify-start px-5 py-3 text-white bg-black"
          >
            <i
              v-if="!this.$store.state.auth.customer"
              class="text-4xl bx bx-user-circle"
            />
            <img
              v-else
              :src="this.$store.state.auth.user.avatar.url"
              class="w-12 h-12 rounded-full"
              :alt="`${this.$store.state.auth.customer.firstName} Profile Image`"
            />
            <div class="hidden ml-5 text-left md:block">
              <span class="text-xl font-semibold text-white">
                Hi,
                <span v-if="this.$store.state.auth.customer">
                  {{ this.$store.state.auth.customer.firstName }}
                  {{ this.$store.state.auth.customer.lastName }}
                </span>
              </span>
              <nuxt-link
                v-if="!this.$store.state.auth.customer"
                to="/signin"
                class="text-xl font-bold hover:text-primary-300"
              >
                Login
              </nuxt-link>
            </div>
          </div>
          <div class="h-screen pt-5 pb-20 overflow-y-scroll bg-white">
            <client-only v-if="groupedProductsByParent">
              <client-only
                v-for="(parent, index) in groupedProductsByParent"
                :key="index"
              >
                <client-only v-if="parent[0].parent">
                  <div v-if="parent[0].parent.node.count > 1" class="mt-5">
                    <h3 class="mb-3" @click="offcanvas = false">
                      <nuxt-link
                        :to="`/category/${parent[0].parent.node.slug}`"
                        class="block px-5 py-2 mb-2 text-xl font-semibold text-black capitalize hover:text-primary-300 bg-secondary-100"
                      >
                        {{ parent[0].parent.node.slug.replace(/-/g, ' ') }}
                        <!-- <span class="ml-5 text-xs">
                          ({{ parent[0].parent.node.count }})
                        </span> -->
                      </nuxt-link>
                    </h3>
                    <ul class="pl-8">
                      <client-only
                        v-for="(category, child_index) in parent"
                        :key="child_index"
                      >
                        <li class="mt-3 first:mt-0" @click="offcanvas = false">
                          <nuxt-link
                            :to="`/category/${category.slug}`"
                            class="hover:text-primary-300 text-secondary-500"
                          >
                            {{ category.name }}
                            <!-- <span class="ml-5 text-xs">
                              ({{ category.count }})
                            </span> -->
                          </nuxt-link>
                        </li>
                      </client-only>
                    </ul>
                  </div>
                </client-only>
              </client-only>
            </client-only>
            <!-- <h3 class="mb-5 text-xl text-black">Categories</h3>
            <ul v-if="categories">
              <li v-for="(category, index) in categories" :key="index"></li>
            </ul> -->
          </div>
        </div>
      </div>

      <div
        id="offcanvasMenu"
        class="top-0 left-0 w-screen h-screen bg-black bg-opacity-75"
        :class="[{ 'z-40 fixed': offcanvasMenu }, { absolute: !offcanvasMenu }]"
      >
        <div
          class="relative z-50 w-3/4 h-screen bg-white shadow-lg sm:w-1/2 md:w-1/4"
          :class="[{ open: offcanvasMenu }]"
        >
          <i
            class="absolute top-0 right-0 mt-2 -mr-16 text-5xl text-white cursor-pointer bx bx-x hover:text-primary-300"
            @click="offcanvasMenu = false"
          ></i>
          <div
            class="flex items-center justify-start px-5 py-3 text-white bg-black"
          >
            <i
              v-if="!this.$store.state.auth.customer"
              class="text-4xl bx bx-user-circle"
            />
            <img
              v-else
              :src="this.$store.state.auth.user.avatar.url"
              class="w-12 h-12 rounded-full"
              :alt="`${this.$store.state.auth.customer.firstName} Profile Image`"
            />
            <div class="ml-5 text-left md:block">
              <span class="text-xl font-semibold text-white">
                Hi,
                <span v-if="this.$store.state.auth.customer">
                  {{ this.$store.state.auth.customer.firstName }}
                  {{ this.$store.state.auth.customer.lastName }}
                </span>
              </span>
              <nuxt-link
                v-if="!this.$store.state.auth.customer"
                to="/signin"
                class="text-xl font-bold hover:text-primary-300"
              >
                Login
              </nuxt-link>
            </div>
          </div>

          <div
            class="flex flex-col items-center justify-between h-screen px-5 pt-5 pb-20 overflow-y-scroll bg-white"
          >
            <ul class="flex flex-col w-full">
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <span @click="offcanvasMenu = false">
                  <nuxt-link
                    to="/"
                    class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                  >
                    Home
                  </nuxt-link>
                </span>
              </li>
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <span @click="offcanvasMenu = false">
                  <nuxt-link
                    to="/shop"
                    class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                  >
                    Shop
                  </nuxt-link>
                </span>
              </li>
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <button
                  class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                  @click="
                    offcanvas = true
                    offcanvasMenu = false
                  "
                >
                  Categories
                </button>
              </li>
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <span @click="offcanvasMenu = false">
                  <nuxt-link
                    :to="{ path: '/shop', query: { maxPrice: 100 } }"
                    class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                    @click="offcanvasMenu = false"
                  >
                    Less than $100
                  </nuxt-link>
                </span>
              </li>
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <span @click="offcanvasMenu = false">
                  <nuxt-link
                    to="/deals"
                    class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                    @click="offcanvasMenu = false"
                  >
                    Deals
                  </nuxt-link>
                </span>
              </li>
            </ul>

            <ul class="flex flex-col w-full mb-8">
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <span @click="offcanvasMenu = false">
                  <nuxt-link
                    to="/cart"
                    class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                  >
                    Cart
                  </nuxt-link>
                </span>
              </li>
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <span @click="offcanvasMenu = false">
                  <nuxt-link
                    to="/profile"
                    class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                  >
                    Profile
                  </nuxt-link>
                </span>
              </li>
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <span @click="offcanvasMenu = false">
                  <nuxt-link
                    to="/orders"
                    class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                  >
                    Orders
                  </nuxt-link>
                </span>
              </li>
              <li class="flex mt-8 md:mt-0 jusitify-center">
                <button
                  class="flex items-center justify-center text-xl leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                  @click.prevent="logOut"
                >
                  Logout
                </button>
              </li>
            </ul>
          </div>
        </div>
      </div>

      <div class="relative z-20">
        <div>
          <!-- Notifications -->
          <div
            id="notification-header-bar"
            :class="[
              { 'hidden md:block': this.$route.name === 'index' },
              { hidden: this.$route.name !== 'index' },
            ]"
          >
            <div
              class="flex items-center justify-center px-2 py-2 bg-secondary-500"
            >
              <span class="text-sm font-semibold text-white md:text-lg">
                Free shipping on orders over US$ 100 with the cuopon code
                <span class="font-bold">FS100</span> !
              </span>
              <div>
                <nuxt-link to="/shop" class="ml-5 btn base primary">
                  Explore
                </nuxt-link>
              </div>
            </div>
          </div>

          <!-- Utilities -->
          <div id="utilities-header-bar" class="px-2 py-4 pr-5 bg-black">
            <div class="container flex items-center justify-between mx-auto">
              <div class="flex items-center flex-none w-1/4 pl-5 md:pl-0">
                <button
                  id="menu-button"
                  class="hidden mr-4 text-4xl text-white md:block hover:text-primary-300 focus:outline-none"
                  @click="offcanvas = true"
                >
                  <i class="bx bx-menu" />
                </button>
                <nuxt-link to="/" target="_parent">
                  <Logo class="h-10" mode="light" />
                </nuxt-link>
              </div>

              <div id="search-bar" class="flex-grow hidden lg:block">
                <form
                  class="flex rounded-md shadow-sm"
                  @submit.prevent="search"
                >
                  <div
                    class="relative flex items-stretch flex-grow focus-within:z-10"
                  >
                    <input
                      id="search-bar-input"
                      v-model="searchBar"
                      type="text"
                      name="search-bar"
                      class="block w-full h-12 px-5 text-black rounded-none rounded-l placeholder-secondary-300 focus:outline-none"
                      placeholder="What are you looking for?"
                    />
                  </div>
                  <button
                    type="submit"
                    class="relative inline-flex items-center px-4 py-2 -ml-px space-x-2 font-medium rounded-r text-secondary-400 bg-primary-300 hover:bg-primary-400 focus:outline-none"
                  >
                    <!-- Heroicon name: search -->
                    <svg
                      class="w-8 h-8 text-white"
                      xmlns="http://www.w3.org/2000/svg"
                      viewBox="0 0 25 25"
                      fill="currentColor"
                      aria-hidden="true"
                    >
                      <path
                        d="M10,18c1.846,0,3.543-0.635,4.897-1.688l4.396,4.396l1.414-1.414l-4.396-4.396C17.365,13.543,18,11.846,18,10 c0-4.411-3.589-8-8-8s-8,3.589-8,8S5.589,18,10,18z M10,4c3.309,0,6,2.691,6,6s-2.691,6-6,6s-6-2.691-6-6S6.691,4,10,4z"
                      />
                    </svg>
                  </button>
                </form>
              </div>

              <div
                id="actions"
                class="flex items-center justify-end flex-none w-1/4"
              >
                <div class="relative flex-shrink-0 block ml-10 md:hidden">
                  <button
                    class="mr-4 text-4xl text-white hover:text-primary-300 focus:outline-none"
                    @click="offcanvasMenu = true"
                  >
                    <i class="bx bx-menu" />
                  </button>
                </div>
                <div
                  id="log-action"
                  class="relative flex-shrink-0 hidden ml-10 mr-5 md:block"
                >
                  <div>
                    <button
                      id="log-button"
                      class="relative flex items-center justify-center text-4xl text-white hover:text-primary-300 focus:outline-none"
                      @click.prevent="openDropdown()"
                    >
                      <i
                        v-if="!this.$store.state.auth.customer"
                        class="bx bx-user"
                      />
                      <img
                        v-else
                        :src="this.$store.state.auth.user.avatar.url"
                        class="w-12 h-12 rounded-full"
                        :alt="`${this.$store.state.auth.customer.firstName} Profile Image`"
                      />

                      <div class="hidden ml-5 text-base text-left md:block">
                        <span class="text-white">
                          Hi,
                          <span v-if="this.$store.state.auth.customer">
                            {{ this.$store.state.auth.customer.firstName }}
                          </span>
                        </span>
                        <br />
                        <span
                          v-if="!this.$store.state.auth.customer"
                          class="font-bold"
                          >Login</span
                        >
                      </div>
                    </button>
                  </div>

                  <div
                    id="log-button-dropdown"
                    class="absolute right-0 w-screen max-w-sm px-10 py-5 mt-5 -mr-5 text-center text-black origin-top-right bg-white rounded shadow-md opacity-50 md:ml-0"
                    :class="[
                      {
                        'transition ease-out duration-100 transform opacity-100 scale-100': logButtonDropdown,
                      },
                      {
                        'transition ease-in duration-75 transform opacity-0 hidden scale-95': !logButtonDropdown,
                      },
                    ]"
                  >
                    <div v-if="!this.$store.state.auth.customer">
                      <!-- <h2 class="mb-4 text-lg font-bold text-secondary-500">
                        Have an account?
                      </h2> -->
                      <nuxt-link
                        to="/signin"
                        target="_parent"
                        class="w-full btn large primary"
                      >
                        Log-In
                      </nuxt-link>
                      <p class="mt-2 text-sm">
                        <span>Are you new?</span>
                        <nuxt-link to="/register" class="text-primary-300">
                          Register here
                        </nuxt-link>
                      </p>
                    </div>
                    <div v-else>
                      <!-- <h2 class="mb-5 text-lg font-bold text-secondary-500">
                        Lorem, ipsum dolor sit amet consectetur adipisicing.
                      </h2> -->

                      <ul class="flex flex-col nav">
                        <li
                          v-for="(menuItem, index) in userMenu"
                          :key="index"
                          class="mb-5"
                        >
                          <nuxt-link
                            :to="menuItem.to"
                            class="flex items-center justify-center text-sm leading-none uppercase md:text-base hover:text-primary-300"
                          >
                            {{ menuItem.label }}
                          </nuxt-link>
                        </li>
                        <li class="flex flex-col">
                          <button
                            class="flex items-center justify-center text-sm leading-none uppercase md:text-base hover:text-primary-300 focus:outline-none"
                            @click.prevent="logOut"
                          >
                            Log Out
                          </button>
                        </li>
                      </ul>

                      <div></div>
                    </div>
                  </div>
                </div>

                <!-- <div id="wishlist-action" class="flex-none hidden ml-5 md:block">
                <button
                  class="text-4xl text-white hover:text-primary-300 focus:outline-none"
                >
                  <i class="bx bx-heart" />
                </button>
              </div> -->

                <div id="cart-action" class="flex-none hidden ml-5 md:block">
                  <nuxt-link
                    to="/cart"
                    class="relative text-4xl text-white hover:text-primary-300 focus:outline-none"
                  >
                    <i class="bx bx-shopping-bag" />
                    <span
                      v-if="this.$store.state.cart.items.length > 0"
                      class="absolute bottom-0 right-0 flex items-center justify-center w-5 h-5 text-sm font-bold leading-none text-white rounded-full bg-primary-300"
                    >
                      {{ this.$store.state.cart.items.length }}
                    </span>
                  </nuxt-link>
                </div>
              </div>
            </div>
          </div>

          <!-- Navigation -->
          <nav id="header-navbar">
            <div
              class="items-center justify-center hidden px-2 py-5 bg-white shadow-sm md:justify-between md:flex"
            >
              <div></div>
              <div>
                <ul class="flex nav">
                  <li class="ml-8 first:ml-0">
                    <nuxt-link
                      to="/"
                      class="flex items-center justify-center text-sm leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                    >
                      Home
                    </nuxt-link>
                  </li>
                  <li class="ml-8 first:ml-0">
                    <nuxt-link
                      to="/shop"
                      class="flex items-center justify-center text-sm leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                    >
                      Shop
                    </nuxt-link>
                  </li>
                  <li class="ml-8 first:ml-0">
                    <button
                      class="flex items-center justify-center text-sm leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                      @click="offcanvas = true"
                    >
                      Categories
                    </button>
                  </li>
                  <li class="ml-8 first:ml-0">
                    <nuxt-link
                      :to="{ path: '/shop', query: { maxPrice: 100 } }"
                      class="flex items-center justify-center text-sm leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                    >
                      Less than $100
                    </nuxt-link>
                  </li>
                  <li class="ml-8 first:ml-0">
                    <nuxt-link
                      to="/deals"
                      class="flex items-center justify-center text-sm leading-none uppercase focus:outline-none md:text-base hover:text-primary-300"
                    >
                      Deals
                    </nuxt-link>
                  </li>
                </ul>
              </div>
              <div></div>
            </div>
          </nav>
        </div>
      </div>
    </header>
  </client-only>
</template>

<script>
import _groupBy from 'lodash/groupBy'
import Logo from '~/components/branding/Logo'

import getProductCategories from '~/apollo/queries/store/getProductCategories.gql'

export default {
  components: {
    Logo,
  },
  data() {
    return {
      userMenu: [
        { to: '/profile', label: 'Profile' },
        { to: '/orders', label: 'My orders' },
      ],
      logButtonDropdown: false,
      offcanvas: false,
      offcanvasMenu: false,
      searchBar: '',
    }
  },
  computed: {
    groupedProductsByParent() {
      return _groupBy(this.categories, (x) => x.parentDatabaseId)
    },
  },
  methods: {
    openDropdown() {
      this.logButtonDropdown = !this.logButtonDropdown
    },
    search() {
      this.$router.push({
        name: 'shop',
        hash: '#store',
        query: { search: this.searchBar },
      })
      this.searchBar = ''
    },
    logOut() {
      this.$store.dispatch('auth/logOut')
      this.$apolloHelpers.onLogout()
    },
  },
  apollo: {
    categories: {
      prefetch: true,
      query: getProductCategories,
      variables() {},
      update(data) {
        return data.productCategories.nodes
      },
    },
  },
}
</script>

<style lang="postcss">
/* div#log-button-dropdown {
  position: absolute;
  left: 50%;
  top: 0;
  transform: translate(-50%, 34%);
}
*/
div#log-button-dropdown::before {
  content: '';
  position: absolute;
  top: 0;
  left: 75%;
  transform: translate(-50%, -100%);
  width: 0;
  height: 0;
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid white;
}
#offcanvas > div.open,
#offcanvasMenu > div.open {
  transform: translateX(0%);
}
#offcanvas > div,
#offcanvasMenu > div {
  transform: translateX(-100%);
  z-index: -9999 !important;
}
#offcanvas > div,
#offcanvas > div.close,
#offcanvasMenu > div,
#offcanvasMenu > div.close {
  transition: all ease-in-out 0.5s;
}
</style>
